/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of IntervalTree.xs. Do not edit this file, edit IntervalTree.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "IntervalTree.xs"
#include <string>
#include <vector>
#include <iostream>
#include <sstream>

extern "C" {
  #include "EXTERN.h"
  #include "perl.h"
  #include "XSUB.h"
  #undef seed
  #undef do_open
  #undef do_close
}

#include "interval_tree.h"

#define do_open   Perl_do_open
#define do_close  Perl_do_close

class SV_ptr {
  SV *sv;
  public:
    SV_ptr() : sv(0) {}
    SV_ptr(SV *sv) : sv(sv) {
      if (sv) SvREFCNT_inc(sv);
    }
    SV_ptr(const SV_ptr &ptr) : sv(ptr.get()) {
      if (sv) SvREFCNT_inc(sv);
    }
    virtual ~SV_ptr() {
      if (sv) SvREFCNT_dec(sv);
    }
    SV_ptr& operator=(SV_ptr ptr) {
      if (sv) SvREFCNT_dec(sv);
      sv = ptr.get();
      if (sv) SvREFCNT_inc(sv);
      return *this;
    }
    bool operator!=(SV_ptr &ptr) {
      return sv != ptr.get();
    }
    bool defined() {
      return sv != 0;
    }
    SV * get() {
      return sv; 
    }
    SV * get() const {
      return sv; 
    }
};

std::ostream& operator<<(std::ostream &out, SV_ptr value) {
  out << "Node:" << value.get();
  return out;
}

class RemoveFunctor {
  SV *callback;
  public:
    RemoveFunctor(SV *callback_) : callback(callback_) {}
    bool operator()(SV_ptr value, long low, long high) const {
      // pass args into callback
      dSP;
      ENTER;
      SAVETMPS;
      PUSHMARK(SP);
      XPUSHs(value.get());
      XPUSHs(sv_2mortal(newSViv(low)));
      XPUSHs(sv_2mortal(newSViv(high+1)));
      PUTBACK;

      // get result from callback and return
      I32 count = call_sv(callback, G_SCALAR);

      SPAGAIN;

      if (count < 1) {
        PUTBACK;
        FREETMPS;
        LEAVE;
        return false;
      }

      SV *retval_sv = POPs;
      bool retval = SvTRUE(retval_sv);

      PUTBACK;
      FREETMPS;
      LEAVE;
      return retval;
    }
};

typedef IntervalTree<SV_ptr,long> PerlIntervalTree;
typedef IntervalTree<SV_ptr,long>::Node PerlIntervalTree_Node;

#line 108 "IntervalTree.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 252 "IntervalTree.c"

XS_EUPXS(XS_Set__IntervalTree_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	PerlIntervalTree *	RETVAL;

	RETVAL = new PerlIntervalTree();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_str)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree *	THIS;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::str() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 106 "IntervalTree.xs"
    std::string str = THIS->str();
    const char *tree = str.c_str();
    RETVAL = newSVpv(tree, 0);
#line 298 "IntervalTree.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_fetch_nearest_up); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_fetch_nearest_up)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, value");
    {
	PerlIntervalTree *	THIS;
	SV *	RETVAL;
	long	value = (long)SvIV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::fetch_nearest_up() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 115 "IntervalTree.xs"
    SV_ptr ptr = THIS->fetch_nearest_up(value);
    SV *ret = ptr.get();
    SvREFCNT_inc(ret);
    RETVAL = ret;
    if (RETVAL == 0)
          XSRETURN_UNDEF;
#line 332 "IntervalTree.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_fetch_nearest_down); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_fetch_nearest_down)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, value");
    {
	PerlIntervalTree *	THIS;
	SV *	RETVAL;
	long	value = (long)SvIV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::fetch_nearest_down() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 127 "IntervalTree.xs"
    SV_ptr ptr = THIS->fetch_nearest_down(value-1);
    SV *ret = ptr.get();
    SvREFCNT_inc(ret);
    RETVAL = ret;
    if (RETVAL == 0)
          XSRETURN_UNDEF;
#line 366 "IntervalTree.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_insert)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "THIS, value, low, high");
    {
	PerlIntervalTree *	THIS;
	SV *	value = ST(1)
;
	long	low = (long)SvIV(ST(2))
;
	long	high = (long)SvIV(ST(3))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::insert() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 140 "IntervalTree.xs"
    if (high <= low) Perl_croak(aTHX_ "Intervals must have positive width");
    SV_ptr ptr(value);
    THIS->insert(ptr, low, high-1);
#line 400 "IntervalTree.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Set__IntervalTree_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_remove)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "THIS, low, high, ...");
    {
	PerlIntervalTree *	THIS;
	AV *	RETVAL;
	long	low = (long)SvIV(ST(1))
;
	long	high = (long)SvIV(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::remove() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 147 "IntervalTree.xs"
    if (high <= low) Perl_croak(aTHX_ "Intervals must have positive width");
    RETVAL = newAV();
    sv_2mortal((SV*)RETVAL);

    if (items > 3) {
      SV *callback = ST(3); 
      RemoveFunctor remove_functor(callback);
      std::vector<SV_ptr> removed;
      THIS->remove(low, high-1, remove_functor, removed);

      for (std::vector<SV_ptr>::iterator
          i=removed.begin(); i!=removed.end(); ++i) 
      {
        SV *value = i->get();
        SvREFCNT_inc(value);
        av_push(RETVAL, value);
      }
    }
    else {
      std::vector<SV_ptr> removed; 
      THIS->remove(low, high-1, removed);

      for (std::vector<SV_ptr>::iterator
          i=removed.begin(); i!=removed.end(); ++i) 
      {
        SV *value = i->get();
        SvREFCNT_inc(value);
        av_push(RETVAL, value);
      }
    }
#line 458 "IntervalTree.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_remove_window); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_remove_window)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "THIS, low, high, ...");
    {
	PerlIntervalTree *	THIS;
	AV *	RETVAL;
	long	low = (long)SvIV(ST(1))
;
	long	high = (long)SvIV(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::remove_window() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 183 "IntervalTree.xs"
    if (high <= low) Perl_croak(aTHX_ "Intervals must have positive width");
    RETVAL = newAV();
    sv_2mortal((SV*)RETVAL);

    if (items > 3) {
      SV *callback = ST(3); 
      RemoveFunctor remove_functor(callback);
      std::vector<SV_ptr> removed;
      THIS->remove_window(low, high-1, remove_functor, removed);

      for (std::vector<SV_ptr>::iterator
          i=removed.begin(); i!=removed.end(); ++i) 
      {
        SV *value = i->get();
        SvREFCNT_inc(value);
        av_push(RETVAL, value);
      }
    }
    else {
      std::vector<SV_ptr> removed; 
      THIS->remove_window(low, high-1, removed);

      for (std::vector<SV_ptr>::iterator
          i=removed.begin(); i!=removed.end(); ++i) 
      {
        SV *value = i->get();
        SvREFCNT_inc(value);
        av_push(RETVAL, value);
      }
    }
#line 522 "IntervalTree.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_fetch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, low, high");
    {
	PerlIntervalTree *	THIS;
	AV *	RETVAL;
	long	low = (long)SvIV(ST(1))
;
	long	high = (long)SvIV(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::fetch() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 220 "IntervalTree.xs"
    if (high <= low) Perl_croak(aTHX_ "Intervals must have positive width");
    RETVAL = newAV();
    sv_2mortal((SV*)RETVAL);
    std::vector<SV_ptr> intervals;
    THIS->fetch(low, high-1, intervals);
    for (size_t i=0; i<intervals.size(); i++) {
      SV *value = intervals[i].get();
      SvREFCNT_inc(value);
      av_push(RETVAL, value);
    }
#line 566 "IntervalTree.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_fetch_window); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_fetch_window)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, low, high");
    {
	PerlIntervalTree *	THIS;
	AV *	RETVAL;
	long	low = (long)SvIV(ST(1))
;
	long	high = (long)SvIV(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::fetch_window() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 237 "IntervalTree.xs"
    if (high <= low) Perl_croak(aTHX_ "Intervals must have positive width");
    RETVAL = newAV();
    sv_2mortal((SV*)RETVAL);
    std::vector<SV_ptr> intervals;
    THIS->fetch_window(low, high-1, intervals);
    for (size_t i=0; i<intervals.size(); i++) {
      SV *value = intervals[i].get();
      SvREFCNT_inc(value);
      av_push(RETVAL, value);
    }
#line 610 "IntervalTree.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Set__IntervalTree__Node_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree__Node_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	PerlIntervalTree_Node *	RETVAL;

	RETVAL = new PerlIntervalTree_Node();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Set::IntervalTree::Node", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree__Node_low); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree__Node_low)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree_Node *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree_Node *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::Node::low() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 261 "IntervalTree.xs"
    RETVAL = THIS->low();
#line 688 "IntervalTree.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree__Node_high); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree__Node_high)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree_Node *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree_Node *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::Node::high() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 268 "IntervalTree.xs"
    RETVAL = THIS->high()+1;
#line 716 "IntervalTree.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree__Node_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree__Node_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree_Node *	THIS;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree_Node *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::Node::value() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 275 "IntervalTree.xs"
    RETVAL = THIS->value().get();
#line 743 "IntervalTree.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Set__IntervalTree__Node_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Set__IntervalTree__Node_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PerlIntervalTree_Node *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (PerlIntervalTree_Node *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Set::IntervalTree::Node::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Set__IntervalTree); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Set__IntervalTree)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Set::IntervalTree::new", XS_Set__IntervalTree_new);
        newXS_deffile("Set::IntervalTree::str", XS_Set__IntervalTree_str);
        newXS_deffile("Set::IntervalTree::fetch_nearest_up", XS_Set__IntervalTree_fetch_nearest_up);
        newXS_deffile("Set::IntervalTree::fetch_nearest_down", XS_Set__IntervalTree_fetch_nearest_down);
        (void)newXSproto_portable("Set::IntervalTree::insert", XS_Set__IntervalTree_insert, file, "$;$;$");
        newXS_deffile("Set::IntervalTree::remove", XS_Set__IntervalTree_remove);
        newXS_deffile("Set::IntervalTree::remove_window", XS_Set__IntervalTree_remove_window);
        (void)newXSproto_portable("Set::IntervalTree::fetch", XS_Set__IntervalTree_fetch, file, "$;$");
        (void)newXSproto_portable("Set::IntervalTree::fetch_window", XS_Set__IntervalTree_fetch_window, file, "$;$");
        newXS_deffile("Set::IntervalTree::DESTROY", XS_Set__IntervalTree_DESTROY);
        newXS_deffile("Set::IntervalTree::Node::new", XS_Set__IntervalTree__Node_new);
        newXS_deffile("Set::IntervalTree::Node::low", XS_Set__IntervalTree__Node_low);
        newXS_deffile("Set::IntervalTree::Node::high", XS_Set__IntervalTree__Node_high);
        newXS_deffile("Set::IntervalTree::Node::value", XS_Set__IntervalTree__Node_value);
        newXS_deffile("Set::IntervalTree::Node::DESTROY", XS_Set__IntervalTree__Node_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
